package tsp.csc4509.tpnote;

/**
 * Classe d'application du client.
 * 
 * @author Eric Lallet.
 *
 */
public final class AppliClient {
	/**
	 * Nombre d'arguments attendus par le main put une requête PUT.
	 */
	private static final int NBPUTARGS = 6;

	/**
	 * Nombre d'arguments attendus par le main put une requête GET.
	 */
	private static final int NBGETARGS = 4;

	/**
	 * position du nom de machine du serveur dans le tableau d'arguments.
	 */
	private static final int USERNAMEARG = 0;

	/**
	 * position du nom de machine du serveur dans le tableau d'arguments.
	 */
	private static final int HOSTARG = 1;

	/**
	 * position du port du serveur dans le tableau d'arguments.
	 */
	private static final int PORTARG = 2;

	/**
	 * position de la requête dans le tableau d'arguments.
	 */
	private static final int REQARG = 3;

	/**
	 * position du destinataire du PUT dans le tableau d'arguments.
	 */
	private static final int DESTARG = 4;

	/**
	 * position du nom du fichier du PUT dans le tableau d'arguments.
	 */
	private static final int FILENAMEARG = 5;

	/**
	 * 
	 */
	private AppliClient() {

	}

	/**
	 * 
	 * @param args
	 * @throws Exception
	 */
	public static void main(final String[] args) throws Exception {
		if ((args.length != NBGETARGS) && (args.length != NBPUTARGS)) {
			usage();
			return;
		}
		String userName = args[USERNAMEARG];
		String hostname = args[HOSTARG];
		int port = Integer.parseInt(args[PORTARG]);
		String requestString = args[REQARG];

		ProtocolMessageType req;
		if (ProtocolMessageType.PUT.toString().equalsIgnoreCase(requestString)) {
			req = ProtocolMessageType.PUT;

		} else if (ProtocolMessageType.GET.toString().equalsIgnoreCase(requestString)) {
			req = ProtocolMessageType.GET;
		} else {
			System.err.println(requestString + " requête non reconnue.");
			usage();
			return;
		}
		Client client = new Client(userName, hostname, port);
		switch (req) {
		case PUT:
			if (args.length != NBPUTARGS) {
				System.err.println("Requête Put mal formatée");
				usage();
				return;
			}
			String destinataire = args[DESTARG];
			String fileName = args[FILENAMEARG];
			client.put(destinataire, fileName);
			break;
		case GET:
			if (args.length != NBGETARGS) {
				System.err.println("Requête Get mal formatée");
				usage();
				return;
			}
			client.get();
			break;
		}

	}

	private static void usage() {
		System.err.println("usage: client <userName> <host> <port> Get");
		System.err.println("ou");
		System.err.println("usage: client <userName> <host> <port> Put <toName> <filename>");
	}
}
