package tsp.csc4509.tpnote;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.nio.channels.FileChannel;
import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;
import java.nio.file.Path;
import java.util.concurrent.Callable;

import tsp.csc4509.spool.Spool;

/**
 * Callable pour le thread qui prend en charge l'envoi et la réception des fichiers
 * en mode synchrone coté serveur.
 * Le call() retourne le chemin vers le répertoire contenant les informations sur
 * le fichier reçu ou émis.
 *  
 * @author 
 *
 */
public class ServerDataTransfertProcessCallable implements Callable<Path>, SenderReceiver {
	/**
	 * Socket serveur crée établir la connexion pour échnager les données contenues
	 * dans le fichier à recevoir ou à émettre. 
	 */
	private ServerSocketChannel listenChannel;
	/**
	 * Chemin vers le répertoire contenant les informations sur le fichier à recevoir ou à émettre.
	 */
	private Path path;
	/**
	 * Message du protocole qui a demandé la réception (message PUT) ou l'envoi (message GET) d'un fichier.
	 */
	private final ProtocolMessage message;


	/**
	 * Constructeur pour initiliser les trois attributs du Callable. 
	 * @param listenChannel
	 *             ServerSocketChannel du DTP du serveur crée pour établir la connexion pour échanger les données contenues
	 *             dans le fichier à recevoir ou à émettre. 
	 * @param path
	 *             Chemin vers le répertoire contenant les informations sur le fichier à recevoir ou à émettre.
	 * @param message
	 *              Message du protocole qui a demandé la réception (message PUT) ou l'envoi (message GET) d'un fichier.
	 */
	public ServerDataTransfertProcessCallable(final ServerSocketChannel listenChannel, final Path path, final ProtocolMessage message) {
		super();
		this.listenChannel = listenChannel;
		this.path = path;
		this.message = message;
	}

	@Override
	public Path call() throws Exception {
		// TODO Question 7
		return null; // pensez à changer le return
	}
}
